﻿var scriptID = "Randomcolor_and_save_jpg";
var i, j, k, l;

if (app.documents.length > 0) {
    var doc = app.activeDocument;
    
    
    if (doc.selection.length == 0) {
        for (i = 0; i < doc.pageItems.length; i++) {
            doc.pageItems[i].selected = true;
        }
        
    }



    var percent = 100;
    
    
    if (isNaN(percent) || percent == 100 || percent.length == 0) {
        
    } else {
        if (percent <= 100) percent = 100;
        if (percent > 100) percent = 100;
    
        var selectedObjects = doc.selection;
        var numSelectedObjects = selectedObjects.length;
        var numRequestedObjects = Math.round(numSelectedObjects * percent / 1);
        var nr = new Number;
        var nrList = new Array;
        var modifiedSelection = new Array;
        
        for (k = 0; k < numSelectedObjects; k++) {
            if (nrList.length >= numRequestedObjects) break;
            nr = getRandomNumber (0, numSelectedObjects-1);
            if  (!(isContainedByArray (nr, nrList))) nrList.push(nr);
        }
        
        doc.selection = [];

        for (l = 0; l < nrList.length; l++) {
            var idx = nrList[l];
            if (selectedObjects[idx] == undefined) {

            } else {
                selectedObjects[idx].selected = true;
            }
        }

    }
} else {
    alert(scriptID + "\nError: No active document \nPlease open a document and try again");
}


function isContainedByArray(num, arr) {
    var x;
    for (x = 0; x < arr.length; x++) {
        if (arr[x] == num) return true;
    }
    return false;
}


function getRandomNumber(min, max) {
        if (min > max) {
                return -1;
        }
        if (min == max) {
                return min;
        }
        return (min + parseInt( Math.random() * (max-min+1)));
}


mySelection = app.activeDocument.selection;
myDoc = app.activeDocument;
if (mySelection instanceof Array)
{
	selSwatches = myDoc.swatches;
	
	if(selSwatches.length != 0)
		for (i=0; i<mySelection.length; i++)
		{
			if(mySelection[i].typename == "PathItem" || mySelection[i].typename == "CompoundPathItem")
			{
				selItem = mySelection[i];
				selItem.filled = true;

				swatchIndex = Math.round( Math.random() * (selSwatches.length - 1 ));
				
				if(selItem.typename == "PathItem")
					selItem.fillColor = selSwatches[swatchIndex].color;
				else
					selItem.pathItems[0].fillColor = selSwatches[swatchIndex].color;
				
			}
		}
}





var big = 1200; 
var small = 400;


if ( app.documents.length > 0 ) { 
    var myDoc = app.activeDocument; 

    var w = myDoc.width;
    var h = myDoc.height;
    var smallSide = Math.min(w, h); 
    var bigSide = Math.max(w, h); 
 
    var scale; 
    if(small/smallSide >= big/bigSide){
        scale = 100*small/smallSide;
    } else {
        scale = 100*big/bigSide;
    }

    if(scale > 776.19) { 
        alert('JPEG тщу save\n\nFor save JPEG\n size\n' + (Math.floor((25.4*w/72)*(scale/776.19))+1)+' x '+Math.floor((25.4*h/72)*(scale/776.19)+1)+' mm');
    } else {
        var fname_str = this.getTargetFile(myDoc.name,  Folder.decode (myDoc.path)); 
        var newJpgFile = new File(fname_str+'.jpg'); 
        var saveJpgOpts = getJpgOptions(scale); 
     
        myDoc.exportFile( newJpgFile, ExportType.JPEG, saveJpgOpts );
    }
}

function getJpgOptions(scale) {

    var saveOpts = new ExportOptionsJPEG();
    saveOpts.antiAliasing = true;
    saveOpts.artBoardClipping = true;
    saveOpts.qualitySetting = 100; 
    saveOpts.horizontalScale = scale;
    saveOpts.verticalScale = scale;
    return saveOpts;
}

function getTargetFile(docName, destFolder) {

    var newName = ""; 
    var newNameNumber = Math.random();

    if (docName.indexOf('.') < 0) { 
        newName = docName + 'test'; 
    } else { 
        var dot = docName.lastIndexOf('.'); 
        newName += docName.substring(0, dot); 
    }
    var myFile = destFolder + '/' + newName + newNameNumber; 
    return myFile; 
}



